(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (factory((global.cogito = {}),global.React));
}(this, (function (exports,React) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  var WithStoreContext = React.createContext({
    store: {}
  });

  var WithStore =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(WithStore, _React$Component);

    function WithStore() {
      _classCallCheck(this, WithStore);

      return _possibleConstructorReturn(this, (WithStore.__proto__ || Object.getPrototypeOf(WithStore)).apply(this, arguments));
    }

    _createClass(WithStore, [{
      key: "render",
      value: function render() {
        var _this = this;

        return React.createElement(WithStoreContext.Consumer, null, function (_ref) {
          var store = _ref.store;
          return React.createElement(WithStoreInner, _extends({
            store: store
          }, _this.props), _this.props.children);
        });
      }
    }]);

    return WithStore;
  }(React.Component);

  Object.defineProperty(WithStore, "Provider", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: function value(_ref3) {
      var _value = _ref3.value,
          children = _ref3.children;
      return React.createElement(WithStoreContext.Provider, {
        value: _value
      }, children);
    }
  });

  var WithStoreInner =
  /*#__PURE__*/
  function (_React$Component2) {
    _inherits(WithStoreInner, _React$Component2);

    function WithStoreInner(_ref2) {
      var _this2;

      var store = _ref2.store,
          selector = _ref2.selector;

      _classCallCheck(this, WithStoreInner);

      _this2 = _possibleConstructorReturn(this, (WithStoreInner.__proto__ || Object.getPrototypeOf(WithStoreInner)).call(this));
      var state = store.getState();
      var dprops = selector(state);
      _this2.state = _objectSpread({}, dprops);
      return _this2;
    }

    _createClass(WithStoreInner, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this3 = this;

        this.unsubscribe = this.props.store.subscribe(function () {
          if (_this3.unmounted) return;

          var state = _this3.props.store.getState();

          var props = _this3.props.selector(state);

          _this3.setState(_objectSpread({}, props));
        });
        this.unmounted = false;
      }
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.unmounted = true;
        this.unsubscribe();
      }
    }, {
      key: "render",
      value: function render() {
        var _props = this.props,
            store = _props.store,
            render = _props.render,
            children = _props.children;
        return render ? render(this.state, store.dispatch) : children(this.state, store.dispatch);
      }
    }]);

    return WithStoreInner;
  }(React.Component);

  var WithStoreMock =
  /*#__PURE__*/
  function (_React$Component) {
    _inherits(WithStoreMock, _React$Component);

    function WithStoreMock() {
      var _ref;

      var _temp, _this;

      _classCallCheck(this, WithStoreMock);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref = WithStoreMock.__proto__ || Object.getPrototypeOf(WithStoreMock)).call.apply(_ref, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "dispatch", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: jest.fn()
      }), _temp));
    }

    _createClass(WithStoreMock, [{
      key: "select",
      value: function select() {
        return this.props.selector(WithStoreMock.state);
      }
    }, {
      key: "render",
      value: function render() {
        var _props = this.props,
            render = _props.render,
            children = _props.children;
        return render ? render(this.select(), this.dispatch) : children(this.select(), this.dispatch);
      }
    }]);

    return WithStoreMock;
  }(React.Component);

  Object.defineProperty(WithStoreMock, "mockStore", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: function value(state) {
      WithStoreMock.state = state;
    }
  });

  exports.WithStore = WithStore;
  exports.WithStoreMock = WithStoreMock;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
